//-----------------------------------------------------------------------------
// SQ7613 
//-----------------------------------------------------------------------------
//*************************************************************************************
// 	: main.c
// 汾		: V
// 		: 
// ˵	: 
// 
// ע		: 
//**************************************************************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif

#include "main.h"

//*********************************************************************
//    : delay_times
//  : ʱ
// ע     : ==> t_1ms   = 0;          // ӳʱ䵥λ ms
//          : ==> t_100us = 1;          // ӳʱ䵥λ usϴ
//          : ɹ̶Ȧʱһʱ䣬ʹ÷£
//          : delay_times(t_1ms, 800);  // ӳ 800ms
//*********************************************************************
void delay_times(uchar tBase, uint x)
{
	uint  i,j;

	for(i=0;i<x;i++)
	{
		for(j=0;j<2000;j++)
		{
			__asm("NOP");
			__asm("NOP");
			__asm("NOP");
		}
	}	
}



/* -----------------------  --------------------------- */
void main()
{
	DI;
	{
		P4DO_P3 = 0;
		P4PU_P3 = 1;
		P4PD_P3 = 0; 
		P4OE_P3 = 1;	// 1 = set p43 been output mode
		P4FC1_P3 = 0;	// 0,0 = set p43 been GPIO type
		P4FC2_P3 = 0;
	}
	EI;
	
	while(1)
	{
		P4DO_P3 = !P4DO_P3;
		delay_times(0,100);
		NOP;  NOP;  NOP;  NOP;  NOP;
	}   
}


/* ---------------------- жϷ ------------------------ */
void __interrupt OnlyReti(void)
{
	__asm("NOP"); 							  // ָ
}

void __interrupt_n OnlyRetn(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n IntWDT(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n IntSWI(void)              // SWIλжϷ
{
	PRSTR7 = 0x5a;
	PRSTR7 = 0xa5;
	PRSTR7 = 0xc3;
	PRSTR7 = 0x3c;	
}
/* -------------------  жϷ ---------------------- */



/* -------------------- SQ7613ж ------------------ */
#pragma section const INT_VECTOR1 0xff40
void * const IntTbl1[] = {											
	OnlyReti,				/* 0xff40 : Reserved		*/									
	OnlyReti,				/* 0xff42 : Reserved		*/									
	OnlyReti,				/* 0xff44 : Reserved		*/									
	OnlyReti,				/* 0xff46 : Reserved		*/								
	OnlyReti,				/* 0xff48 : Reserved		*/									
	OnlyReti,				/* 0xff4a : Reserved		*/									
	OnlyReti,				/* 0xff4c : Reserved		*/									
	OnlyReti,				/* 0xff4e : Reserved		*/									
	OnlyReti,				/* 0xff50 : Reserved		*/									
	OnlyReti,				/* 0xff52 : Reserved		*/									
	OnlyReti,				/* 0xff54 : Reserved		*/									
	OnlyReti,				/* 0xff56 : Reserved		*/									
	OnlyReti,				/* 0xff58 : IntTCA7			*/	//жԴ:TCA7 16λʱ								
	OnlyReti,				/* 0xff5a : IntTCA6			*/	//жԴ:TCA6 16λʱ							
	OnlyReti,				/* 0xff5c : Reserved		*/									
	OnlyReti,				/* 0xff5e : Reserved		*/									
	OnlyReti,				/* 0xff60 : Reserved		*/									
	OnlyReti,				/* 0xff62 : Reserved		*/									
	OnlyReti,				/* 0xff64 : Reserved		*/									
	OnlyReti,				/* 0xff66 : Reserved		*/									
	OnlyReti,				/* 0xff68 : Reserved		*/									
	OnlyReti,				/* 0xff6a : Reserved		*/									
	OnlyReti,				/* 0xff6c : IntTX2			*/	//жԴ:UART2 TX2								
	OnlyReti,				/* 0xff6e : IntRX2			*/	//жԴ:UART2 RX2							
	OnlyReti,				/* 0xff70 : Reserved		*/									
	OnlyReti,				/* 0xff72 : Reserved		*/									
	OnlyReti,				/* 0xff74 : Reserved		*/									
	OnlyReti,				/* 0xff76 : IntTCA5			*/	//жԴ:TCA5 16λʱ								
	OnlyReti,				/* 0xff78 : IntTCA4			*/	//жԴ:TCA4 16λʱ								
	OnlyReti,				/* 0xff7a : Reserved		*/									
	OnlyReti,				/* 0xff7c : Reserved		*/									
	OnlyReti,				/* 0xff7e : Reserved		*/									
	OnlyReti,				/* 0xff80 : Reserved		*/									
	OnlyReti,		    	/* 0xff82 : Reserved		*/									
	OnlyReti,	    		/* 0xff84 : Reserved		*/									
	OnlyReti,				/* 0xff86 : Reserved		*/									
	OnlyReti,				/* 0xff88 : Reserved		*/									
	OnlyReti,				/* 0xff8a : Reserved		*/									
	OnlyReti,				/* 0xff8c : IntSIO1			*/	//жԴ:SIO 1								
	OnlyReti,				/* 0xff8e : IntI2C1			*/	//жԴ:I2C 1						
	OnlyReti,				/* 0xff90 : IntTX1			*/	//жԴ:UART1 TX1							
	OnlyReti,	//IntRX1,					/* 0xff92 : IntRX1			*/	//жԴ:UART1 RX1								
	OnlyReti,				/* 0xff94 : Reserved		*/									
	OnlyReti,				/* 0xff96 : Reserved		*/									
	OnlyReti,				/* 0xff98 : Reserved		*/									
	OnlyReti,				/* 0xff9a : IntTCA3			*/	//жԴ:TCA3 16λʱ							
	OnlyReti,				/* 0xff9c : IntTCA2			*/	//жԴ:TCA2 16λʱ								
	OnlyReti,				/* 0xff9e : Reserved		*/									
	OnlyReti,				/* 0xffa0 : IntMAC			*/	//жԴ:˷								
	OnlyReti,				/* 0xffa2 : IntEXT7			*/	//ⲿж7								
	OnlyReti,				/* 0xffa4 : IntEXT6			*/	//ⲿж6								
	OnlyReti,				/* 0xffa6 : IntEXT5			*/	//ⲿж5								
	OnlyReti,				/* 0xffa8 : IntEXT4			*/	//ⲿж4								
	OnlyReti,				/* 0xffaa : Reserved		*/									
	OnlyReti,				/* 0xffac : Reserved		*/									
	OnlyReti,				/* 0xffae : Reserved		*/							
	OnlyReti,				/* 0xffb0 : IntDIC			*/	//жԴ:DIC								
	OnlyReti,				/* 0xffb2 : Reserved		*/							
	OnlyReti,				/* 0xffb4 : Reserved		*/									
	OnlyReti,				/* 0xffb6 : Reserved		*/									
	OnlyReti,				/* 0xffb8 : Reserved		*/									
	OnlyReti,				/* 0xffba : Reserved		*/									
	OnlyReti,				/* 0xffbc : Reserved		*/									
	OnlyReti,				/* 0xffbe : Reserved		*/									
	OnlyReti,				/* 0xffc0 : Reserved		*/									
	OnlyReti,				/* 0xffc2 : Reserved		*/									
	OnlyReti,				/* 0xffc4 : IntFMC			*/	//жԴ:Flash								
	OnlyReti,				/* 0xffc6 : Reserved		*/					
	OnlyReti,				/* 0xffc8 : Reserved		*/									
	OnlyReti,				/* 0xffca : Reserved		*/									
	OnlyReti,				/* 0xffcc : Reserved		*/									
	OnlyReti,               /* 0xffce : IntADC			*/	//жԴ:ADC								
	OnlyReti,				/* 0xffd0 : IntEXT3			*/	//ⲿж3								
	OnlyReti,				/* 0xffd2 : IntEXT2			*/	//ⲿж2								
	OnlyReti,				/* 0xffd4 : IntEXT1			*/	//ⲿж1								
	OnlyReti,				/* 0xffd6 : IntEXT0			*/	//ⲿж0								
	OnlyReti,				/* 0xffd8 : IntSIO0			*/	//жԴ:SIO 0								
	OnlyReti,				/* 0xffda : IntI2C0			*/	//жԴ:I2C 0								
	OnlyReti,				/* 0xffdc : IntTX0			*/	//жԴ:UART0 TX0								
	OnlyReti,				/* 0xffde : IntRX0			*/	//жԴ:UART0 RX0								
	OnlyReti,				/* 0xffe0 : Reserved		*/									
	OnlyReti,				/* 0xffe2 : Reserved		*/									
	OnlyReti,				/* 0xffe4 : Reserved		*/									
	OnlyReti,				/* 0xffe6 : IntTCA1			*/	//жԴ:TCA1 16λʱ								
	OnlyReti,				/* 0xffe8 : IntTCA0			*/	//жԴ:TCA0 16λʱ								
	OnlyReti,				/* 0xffea : Reserved		*/									
	OnlyReti,				/* 0xffec : Reserved		*/									
	OnlyReti,			    /* 0xffee : IntRTC			*/	//жԴ:ʵʱʱRTCʱ								
	OnlyReti,				/* 0xfff0 : IntTBT			*/  //жԴ:ʱTBTʱ				
	OnlyReti,				/* 0xfff2 : Reserved		*/									
	OnlyReti,				/* 0xfff4 : IntCFD			*/	//жԴ:ʱʧЧ								
	OnlyReti,				/* 0xfff6 : IntLVD			*/	//жԴ:͵ѹLVD							
	IntWDT,					/* 0xfff8 : IntWDT			*/	//non-maskable жԴ:Źʱ		
	(void *)0xffff,			/* 0xfffa : Reserved		*/									
	IntSWI,					/* 0xfffc : IntSWI/INTUNDEF */	//non-maskable	
	
	// Boot mark start
	iap_boot,				/* 0xfffe : RESET			*/	//non-maskable
	// Boot mark end			
};
#pragma section const
/* -------------------  SQ7613ж ---------------------- */



/* ----------------------- IAP(Ҫ޸Ĵ˴ code) --------------------------- */
#pragma section code	c_value

void IAP_Init()
{
    // Memory address related
	IAP_Dev_define.norBootAddr = NORMAL_BOOT_ADDRESS;
	
	// BOOT PIN select
	IAP_Dev_define.ptrBootPinFC = IAP_BOOT_PIN_FUNCTION_ADR;
	IAP_Dev_define.ptrBootPinPU = IAP_BOOT_PIN_PULL_UP_ADR;
	IAP_Dev_define.ptrBootPinPD = IAP_BOOT_PIN_PULL_DOWN_ADR;
	IAP_Dev_define.ptrBootPinCR = IAP_BOOT_PIN_CONTROL_ADR;
	IAP_Dev_define.ptrBootPinPRD = IAP_BOOT_PIN_INPUT_ADR;
	IAP_Dev_define.valBootPinBit = IAP_BOOT_PIN_SELECT;
	IAP_Dev_define.valBootDefaultHL = IAP_BOOT_GPIO_DEFAULT_HIGH_LOW;
	IAP_Dev_define.valBootEnableHL =IAP_BOOT_GPIO_ENABLE_HIGH_LOW;
	
	// UART select
	IAP_Dev_define.ptrUartPinCR = IAP_UART_CR_ADR;
    IAP_Dev_define.ptrUartPinFC = IAP_UART_FC_ADR;
    IAP_Dev_define.valUartTxPin = IAP_UART_TX_PIN;
	IAP_Dev_define.valUartRxPin = IAP_UART_RX_PIN;
	
	IAP_Dev_define.ptrUartTxBuf = IAP_UART_TDBUF_ADR;
	IAP_Dev_define.ptrUartRxBuf = IAP_UART_RDBUF_ADR;	
	IAP_Dev_define.ptrUartSR    = IAP_UART_SR_ADR;
	IAP_Dev_define.ptrUartDR    = IAP_UART_DR_ADR;
	IAP_Dev_define.ptrUartCR1   = IAP_UART_CR1_ADR;
	IAP_Dev_define.ptrUartCR2   = IAP_UART_CR2_ADR;
	
	IAP_Dev_define.ptrPxPU	    = IAP_PxPU_ADR;
}
#pragma section code
/* ----------------------- IAP End --------------------------- */

